<script setup lang="ts">
import { ref } from 'vue'
import MainMenu from './MainMenu.vue'
import { getTimeNowString } from '@/utils/constants'
import { useNavStore } from '@/stores/navigation'
import { useDisplay } from 'vuetify'
import { useAuthStore } from '@/stores/auth'
import { baseUrlImage } from '@/services/http'
import { computed } from 'vue'
import OptionsDrawer from './OptionsDrawer.vue'

const authStore = useAuthStore()
const navStore = useNavStore()
const rail = ref(true)
const timeNow = ref()
const isOptionDisplay = ref<boolean>(false)

setInterval(() => {
  timeNow.value = getTimeNowString()
}, 1000)

const avatarImage = computed(() => {
  if (authStore.isCustomer()) {
    return `${baseUrlImage}/customers/${authStore.getCurrentUser()?.image}`
  }
  return `${baseUrlImage}/employees/${authStore.getCurrentUser()?.image}`
})
</script>

<template>
  <v-app-bar v-if="navStore.showAppBar" color="brown-darken-4" flat density="compact">
    <template v-slot:prepend>
      <v-app-bar-nav-icon
        v-if="useDisplay().mdAndDown.value"
        variant="text"
        @click="navStore.switchDrawer()"
      ></v-app-bar-nav-icon>
      <v-img class="d-flex ma-0 pa-0" width="40" cover src="src/assets/MainLogo.png"></v-img>
    </template>
    <v-app-bar-title>
      <p class="ma-auto">D-Coffee</p>
    </v-app-bar-title>

    <template v-slot:append>
      <div class="mx-5">
        {{ timeNow }}
      </div>
      <!-- <v-menu>
        <template #activator="{ props }">
          <v-btn v-bind="props" size="default" icon="mdi-bell"> </v-btn>
        </template>
        <v-card rounded="lg" class="pa-3">
          <v-row>
            <v-col>
              <p class="pa-3">Notification</p>
            </v-col>
            <v-spacer></v-spacer>
            <v-col class="ma-auto">
              <v-btn flat size="small" icon="mdi-cog"></v-btn>
            </v-col>
          </v-row>
          <v-divider></v-divider>
          <v-list>
            <v-list-item> testMsg </v-list-item>
          </v-list>
        </v-card>
      </v-menu> -->
      <v-menu>
        <template #activator="{ props }">
          <v-avatar v-bind="props" style="cursor: pointer" :image="avatarImage"> </v-avatar>
        </template>
        <v-card rounded="lg">
          <v-list>
            <v-list-item prepend-icon="mdi-account" title="Profile" :to="{ path: '/profile' }">
            </v-list-item>
            <v-list-item prepend-icon="mdi-cog" title="Settings" @click="isOptionDisplay = true">
            </v-list-item>
            <v-list-item prepend-icon="mdi-logout" title="Logout" @click="authStore.logout()">
            </v-list-item>
          </v-list>
        </v-card>
      </v-menu>
    </template>
  </v-app-bar>
  <div v-show="rail" class="slide-animation">
    <MainMenu v-if="navStore.showAppBar" />
  </div>
  <OptionsDrawer v-model:is-open="isOptionDisplay"></OptionsDrawer>
</template>
<style>
.slide-animation {
  transition: transform 0.3s ease; /* เพิ่ม transition effect ในการเปลี่ยนแปลงตำแหน่ง */
}

.slide-animation-enter-active,
.slide-animation-leave-active {
  transition: transform 0.3s ease;
}

.slide-animation-enter,
.slide-animation-leave-to {
  transform: translateY(100%);
}
</style>
